use crate::parser::template;
use crate::parser::Template;
use nom::IResult;

#[derive(Clone, Debug)]
pub struct CompiledTemplate<'a> {
    template: Template<'a>,
    name: String,
}

pub fn compile_template<'a>(source: &'a str, name: String) -> CompiledTemplate<'a> {
    // TODO: Make this function return a result with a custom error type. Break the nom IResult chain
    // TODO: Make this all consuming
    let (_remaining, parsed_template) = template(source).expect("Failed to compile template");
    CompiledTemplate {
        template: parsed_template,
        name: name,
    }
}
